; +++ User Defined Control Example +++
; +++++ Programmed by Luis Costa +++++
; ++++ Lisboa, 21st January,2012 +++++
; +++ contact:xandaz@hotmail.com +++++
; +++ morethangeeks.orgfree.com ++++++

__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
RegisterControl PROTO   

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\macros\macros.asm

.const  
MainWindowWidth     equ     600
MainWindowHeight    equ     400

.data
hInstance       HINSTANCE       ?
hMainWindow     HWND            ?
UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "Standard Window",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>

UCSTR           szuUDControlClass,"UDCONTROL",0
hCtrl           dd              ?

rect            RECT            <>
UCSTR           SomeFuckingText,"Some fucking text for this Static user defined control",0
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  GetClientRect,hWnd,addr rect
            invoke  RegisterControl
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr szuUDControlClass,0,\
                        WS_VISIBLE+WS_CHILD,0,0,rect.right,20,hWnd,0,hInstance,0
            mov     hCtrl,eax 
            invoke  SendMessage,hCtrl,WM_SETTEXT,NULL,addr SomeFuckingText                                   
        .endif
    .elseif uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp                                                

RegisterControl PROC

    local   wc:WNDCLASSEX

    mov     wc.cbSize,sizeof wc
    mov     wc.style,CS_HREDRAW+CS_VREDRAW
    mov     wc.lpfnWndProc,offset CtrlProc
    push    hInstance
    pop     wc.hInstance
    mov     wc.cbWndExtra,0
    mov     wc.cbClsExtra,0
    mov     wc.lpszClassName,offset szuUDControlClass
    mov     wc.lpszMenuName,0
    mov     wc.hCursor,0
    mov     wc.hIcon,0
    mov     wc.hIconSm,0
    mov     wc.hbrBackground,COLOR_WINDOW
    invoke  RegisterClassEx,addr wc
    ret

RegisterControl endp

.data
ps      PAINTSTRUCT     <>
rect2   RECT            <>
hParent dd              ?
lpText  dd              ?
TEXT    dd              ?
clrBrush    dd          ?

.code
CtrlProc    PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

   
    .if     uMsg==WM_CREATE
        mov     edi,lParam
        assume  edi:PTR CREATESTRUCT
        push    [edi].hWndParent
        pop     hParent
        invoke  GetClassLong,[edi].hWndParent,GCL_HCURSOR
        invoke  SetCursor,eax
        invoke  GetClassLong,[edi].hWndParent,GCL_HBRBACKGROUND
        mov     clrBrush,eax
        push    [edi].x
        pop     rect2.left
        push    [edi].y
        pop     rect2.top
        push    [edi].lx
        pop     rect2.right
        push    [edi].ly
        pop     rect2.bottom
        mov     TEXT,FALSE

    .elseif uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
        invoke  SetTextColor,ps.hdc,1
        invoke  SetBkMode,ps.hdc,TRANSPARENT
        .if     TEXT==TRUE
                invoke  DrawText,ps.hdc,lpText,-1,addr ps.rcPaint,DT_LEFT
        .endif
        invoke  EndPaint,hWnd,addr ps
                    
    .elseif uMsg==WM_SETTEXT
        push    lParam
        pop     lpText
        mov     TEXT,TRUE
        invoke  SendMessage,hWnd,WM_PAINT,0,0
    .else   
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    mov eax,1
    ret

CtrlProc    endp
end     start